##################################
### Lusers.tcl                 ###
### Version 1.3                ###
### By Wcc                     ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

####################################################################################
## This script writes the output of /LUSERS to an HTML web page every X seconds.  ##
####################################################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

################################################
# Set the filename of the stats web page here. #
################################################

set lusers_setting(page) "../web/lusers.html"

######################################################################
# Set here the path to the DAWG template file you would like to use. #
# You can obtain templates by visiting http://dawg.oc255.net:81/ and #
# clicking the templates link.                                       #
######################################################################

set lusers_setting(tpl) "./scripts/Lusers_DAWG.tpl"

#############################################
# How often should the web page be updated? #
#############################################

set lusers_setting(timer_update) "170"

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002LUSERS:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002LUSERS:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

foreach rb {251 252 254 255 265 266} { bind raw - $rb lusers_write_lusers }

if {![string match "* lusers_update *" [utimers]]} { utimer $lusers_setting(timer_update) lusers_update }

set lusers_setting(version) "1.3"
set lusers_notpl 0

if {![info exists lusers_setting(tpl)] || [catch {source $lusers_setting(tpl)}]} {
	putlog "\002LUSERS:\002 The template file could not be opened; using default."
	set lusers_notpl 1
}
foreach {s v} [list Page_CC #000000 Page_HC #000000 Page_LinkC #0000FF Page_TTextC #000000 Page_TextC #000000 Page_BGC \
	#FFFFFF Page_TCC_2 #E0E0E0 Page_TCC_1 #C0C0C0 Page_THC_2 #8080E0 Page_THC_1 #8080C0 Page_TCS 4 Page_THS 5 Page_TitleS 6 \
	Page_Title {Network Status} Page_TitleTag {Network Users} Page_Img {}] {
	if {$lusers_notpl || ![info exists lusers_setting($s)]} { set lusers_setting($s) $v  }
}
proc lusers_format_td {type line center text} {
	switch -- $type {
		"title" { return "<font size=\"$::lusers_setting(Page_THS)\" color=\"$::lusers_setting(Page_TextC)\">[expr ($center)?{<center>}:{}]$text[expr ($center)?{</center>}:{}]</font>" }
		"header" { return "<td align=\"left\" bgcolor=\"$::lusers_setting(Page_THC_${line})\"><font size=\"$::lusers_setting(Page_THS)\" color=\"$::lusers_setting(Page_HC)\">[expr ($center)?{<center>}:{}]$text[expr ($center)?{</center>}:{}]</font></td>" }
		"cell" { return "<td align=\"left\" bgcolor=\"$::lusers_setting(Page_TCC_${line})\"><font size=\"$::lusers_setting(Page_TCS)\" color=\"$::lusers_setting(Page_CC)\">[expr ($center)?{<center>}:{}]$text[expr ($center)?{</center>}:{}]</font></td>" }
	}
}
proc lusers_write_lusers {from keyword text} {
	set ::lusers_localserver $from
	if {[regexp 252|254 $keyword]} { regsub -all -- ":" $text "" text }
	set ::lusers_lusers_data($keyword) [string trimleft [join [lrange [split $text] 1 end]] :]
	if {$keyword == 266} { lusers_do_final }
}
proc lusers_do_final {} {
	set stats [open $::lusers_setting(page) w]	
	puts $stats "<html>\n  <head>\n    <title>$::lusers_setting(Page_TitleTag)</title>\n    <META NAME=\"description\" CONTENT=\"Network Users\">\n    <META NAME=\"keywords\" CONTENT=\"lusers, irc, eggdrop, tcl, link\">\n  </head>\n\n  <body bgcolor=\"$::lusers_setting(Page_BGC)\" link=\"$::lusers_setting(Page_LinkC)\" alink=\"$::lusers_setting(Page_LinkC)\" vlink=\"$::lusers_setting(Page_LinkC)\">"
	if {[string compare $::lusers_setting(Page_Img) ""] != 0} { puts $stats "    <center><img src=\"$::lusers_setting(Page_Img)\"></img></center>" }
	puts $stats "    <center><font size=\"$::lusers_setting(Page_TitleS)\" color=\"$::lusers_setting(Page_TTextC)\">$::lusers_setting(Page_Title)</font></center>\n    <br>\n    <center><font size=\"$::lusers_setting(Page_TCS)\" color=\"$::lusers_setting(Page_TextC)\">Connected to $::lusers_localserver on port [lindex [split $::server :] 1].</font></center>\n    <br>\n    <br>\n    <br>\n    [lusers_format_td title 0 1 {Network Users}]\n    <br>\n    <table align=\"center\">\n      <tr>\n        [lusers_format_td header 1 1 {Network Users}]\n      </tr>\n      <tr>\n        <td align=\"left\" bgcolor=\"$::lusers_setting(Page_TCC_1)\"><font size=\"$::lusers_setting(Page_TCS)\" color=\"$::lusers_setting(Page_CC)\">\n<pre>\n"
	foreach i [array names ::lusers_lusers_data] { puts $stats "   $::lusers_lusers_data($i)   " }
	puts $stats "</pre>\n        </td>\n      </tr>\n    </table>\n    <br>\n    <br>\n    <center><font color=\"$::lusers_setting(Page_TextC)\">Last Updated: [clock format [clock seconds] -format {%I:%M %p %D}]</font></center>\n  </body>\n</html>\n<!--<DAWGID>Lusers $::lusers_setting(version)</DAWGID>-->"
	close $stats
}
proc lusers_update {} {
	putserv "LUSERS"
	if {![string match "* lusers_update *" [utimers]]} { utimer $::lusers_setting(timer_update) lusers_update }
}
putlog "\002LUSERS:\002 Lusers.tcl Version $lusers_setting(version) by Wcc is loaded."